DROP TYPE rodne_cislo CASCADE;

CREATE OR REPLACE FUNCTION rodne_cislo_in (cstring) 
  RETURNS rodne_cislo AS 'rodne_cislo_typ.so','rodne_cislo_in' LANGUAGE 'C';

CREATE OR REPLACE FUNCTION rodne_cislo_out (rodne_cislo) 
  RETURNS cstring AS 'rodne_cislo_typ.so', 'rodne_cislo_out' LANGUAGE 'C';
 
-- poprve se vypise varovani, ze typ rodne_cislo neni

CREATE TYPE rodne_cislo (
  internallength = 8,
  input          = rodne_cislo_in,
  output         = rodne_cislo_out
);

CREATE OR REPLACE FUNCTION rodne_cislo_todate (rodne_cislo)
  RETURNS date AS 'rodne_cislo_typ.so', 'rodne_cislo_todate' 
  LANGUAGE 'C' STRICT IMMUTABLE;

CREATE OR REPLACE FUNCTION rodne_cislo_tobpchar (rodne_cislo)
  RETURNS char AS 'rodne_cislo_typ.so', 'rodne_cislo_tobpchar' 
  LANGUAGE 'C' STRICT IMMUTABLE;

DROP CAST (rodne_cislo AS date);

CREATE CAST (rodne_cislo AS date) 
  WITH FUNCTION rodne_cislo_todate (rodne_cislo);

DROP CAST (rodne_cislo AS char);

CREATE CAST (rodne_cislo AS char)
  WITH FUNCTION rodne_cislo_tobpchar (rodne_cislo);
